//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace Bon
{
	/// <summary>
	/// URLC^[tFCXłB
	/// </summary>
	[ComVisible(true)]
	[Guid("E214D4D7-7A31-45fd-86C9-E7351B58A85E")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	[TypeConverter(typeof(UriTypeConverter))]
	public interface IUrl
	{
		string AbsolutePath { get; }
		string AbsoluteUrl { get; }
		string Authority { get; }
		string DnsSafeHost { get; }
		string Fragment { get; }
		string Host { get; }
		bool IsAbsoluteUrl { get; }
		bool IsDefaultPort { get; }
		bool IsFile { get; }
		bool IsLoopback { get; }
		bool IsUnc { get; }
		string LocalPath { get; }
		string OriginalString { get; }
		string PathAndQuery { get; }
		int Port { get; }
		string Query { get; }
		string Scheme { get; }
		string[] Segments { get; }
		bool UserEscaped { get; }
		string UserInfo { get; }
		[ComVisible(false)]
		Uri Uri { get; }
		bool Equals(IUrl url);
		string ToString();
	}

	/// <summary>
	/// IUrlC^[tFCX̃CX^X𐶐C^[tFCXłB
	/// </summary>
	/// <remarks>̃C^[tFCXCOM݉^pŎgp܂B</remarks>
	[ComVisible(true)]
	[Guid("0226941C-6E47-498c-A24F-82D61518A92A")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	public interface IUrlBuilder
	{
		string Fragment { get; set; }
		string Host { get; set; }
		string Password { get; set; }
		string Path { get; set; }
		int Port { get; set; }
		string Query { get; set; }
		string Scheme { get; set; }
		IUrl Url { get; }
		string UserName { get; set; }
	}
}
