//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interface library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration.Install;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

namespace Bon.Internal
{
	/// <summary>
	/// COM݉^pAZuCXg[NXłB
	/// </summary>
	/// <remarks>
	/// ̃vWFNg̃AZúACOM݉^p̂߂GACւ̔zuCOMւ̓o^sKv܂B
	/// ʏ̓CXg[vWFNgGACւ̔zuCOMւ̓o^sōς݂܂A
	/// VS2005̃CXg[vWFNgɂ̓oOA64rbgWindowsɂCOMւ̓o^Ɏs܂B
	/// ̂߁AŎ蓮COMւ̓o^s܂B
	/// </remarks>
	[DesignTimeVisible(false)]
	public sealed class ComRegisterInstaller : Installer, ITypeLibExporterNotifySink
	{
		[ComVisible(false)]
		[Guid("00020406-0000-0000-C000-000000000046")]
		[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
		private interface UCOMICreateITypeLib
		{
			void CreateTypeInfo();
			void SetName();
			void SetVersion();
			void SetGuid();
			void SetDocString();
			void SetHelpFileName();
			void SetHelpContext();
			void SetLcid();
			void SetLibFlags();
			void SaveAllChanges();
		}

		private static readonly IRegistrationServices service_ = new RegistrationServices();
		private static readonly ITypeLibConverter converter_ = new TypeLibConverter();
		private static readonly IArchitecture architecture_ = new Architecture();

		/// <summary>
		/// RXgN^łB
		/// </summary>
		public ComRegisterInstaller()
		{
		}

		private string GetTypeLibPath(Assembly assembly)
		{
			string fileName = string.Format("{0}.tlb", Path.GetFileNameWithoutExtension(assembly.Location));
			return Path.Combine(Path.GetDirectoryName(assembly.Location), fileName);
		}

		/// <summary>
		/// CXg[s܂B
		/// </summary>
		/// <param name="stateSaver"></param>
		public override void Install(System.Collections.IDictionary stateSaver)
		{
			Assembly assembly = Assembly.GetExecutingAssembly();
			service_.RegisterAssembly(assembly, AssemblyRegistrationFlags.SetCodeBase);

			TypeLibExporterFlags flags = TypeLibExporterFlags.None;
			switch (architecture_.CurrentProcess)
			{
				case ProcessorArchitecture.INTEL:
					flags = TypeLibExporterFlags.ExportAs32Bit;
					break;
				case ProcessorArchitecture.AMD64:
					flags = TypeLibExporterFlags.ExportAs64Bit;
					break;
				default:
					throw new InvalidOperationException(
						"Operation system platform not supported: " + architecture_.CurrentProcess.ToString());
			}

			string filePath = GetTypeLibPath(assembly);
			UCOMICreateITypeLib typeLib = (UCOMICreateITypeLib)converter_.ConvertAssemblyToTypeLib(
				assembly, filePath, flags, this);
			typeLib.SaveAllChanges();

			stateSaver.Add("typeLibPath", filePath);

			base.Install(stateSaver);
		}

		/// <summary>
		/// [obNs܂B
		/// </summary>
		/// <param name="savedState"></param>
		public override void Rollback(System.Collections.IDictionary savedState)
		{
			base.Rollback(savedState);
			try
			{
				string filePath = savedState["typeLibPath"] as string;
				if (filePath != null)
				{
					File.Delete(filePath);
				}

				Assembly assembly = Assembly.GetExecutingAssembly();
				service_.UnregisterAssembly(assembly);
			}
			catch
			{
			}
		}

		/// <summary>
		/// ACXg[s܂B
		/// </summary>
		/// <param name="savedState"></param>
		public override void Uninstall(System.Collections.IDictionary savedState)
		{
			base.Uninstall(savedState);
			try
			{
				string filePath = savedState["typeLibPath"] as string;
				if (filePath != null)
				{
					File.Delete(filePath);
				}

				Assembly assembly = Assembly.GetExecutingAssembly();
				service_.UnregisterAssembly(assembly);
			}
			catch
			{
			}
		}

		void ITypeLibExporterNotifySink.ReportEvent(ExporterEventKind eventKind, int eventCode, string eventMsg)
		{
		}

		object ITypeLibExporterNotifySink.ResolveRef(Assembly assembly)
		{
			return null;
		}
	}
}
