//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class Tuner;

	ref class DataQueue sealed
		: public IDataQueue
	{
	private:
		Tuner^ parent_;
		initonly __int64 maxSize_;
		initonly System::Collections::Generic::Queue<ITsData^>^ queue_;
		initonly System::Threading::ManualResetEvent^ queued_;
		__int64 totalSize_;
		int programID_;

	internal:
		DataQueue(Tuner^ parent, int programID, __int64 maxSize);

		void SetProgramID(int programID);
		void Enqueue(ITsData^ data);
		void Close();

	public:
		~DataQueue();

		virtual void Clear();

		property System::Threading::WaitHandle^ CanDequeue
		{
			virtual System::Threading::WaitHandle^ get();
		}

		property System::IntPtr CanDequeueHandle
		{
			virtual System::IntPtr get();
		}

		property int Count
		{
			virtual int get();
		}

		property __int64 MaxSize
		{
			virtual __int64 get();
		}

		property __int64 TotalSize
		{
			virtual __int64 get();
		}

		property int ProgramID
		{
			virtual int get();
			virtual void set(int programID);
		}

		virtual ITsData^ Dequeue();

		virtual IRawTsData^ RawDequeue();
	};
}
