//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "ManagedBuffer.h"
#include "DataQueueManager.h"
#include "DataQueue.h"
#include "TsData.h"

namespace Bon
{
	namespace Internal
	{
		DataQueueManager::DataQueueManager(int bufferSize)
			: pBuffer_(new ManagedBuffer(bufferSize)),
			queueList_(gcnew System::Collections::Generic::List<DataQueue^>())
		{
			// ManagedBufferNXgƂŁA}l[Wzւ̐̃|C^g
			// ɃRs[鎖oB
		}

		DataQueueManager::~DataQueueManager()
		{
			if (pBuffer_ != 0)
			{
				for (int i = 0; i < queueList_->Count; i++)
				{
					queueList_->default::get(i)->Close();
				}

				queueList_->Clear();

				delete pBuffer_;
				pBuffer_ = 0;
			}
		}

		void DataQueueManager::RegisterQueue(DataQueue ^queue)
		{
			queueList_->Add(queue);
		}

		int DataQueueManager::UnregisterQueue(DataQueue^ queue)
		{
			queueList_->Remove(queue);
			return queueList_->Count;
		}

		void DataQueueManager::Clear()
		{
			for (int i = 0; i < queueList_->Count; i++)
			{
				queueList_->default::get(i)->Clear();
			}
		}

		void DataQueueManager::Enqueue(const BYTE *pData, DWORD dataSize)
		{
			// Ŏw肳f[^͔ɍׂTCYȂ̂ŁAõobt@ɓB
			// obt@TCY𒴂Ă܂ꍇ́Alߍ܂Ɍ݂̃TCY܂łƂ
			// L[ɓi}l[Wz̊g͏oȂAoƂĂptH[}X
			// ɉeƎv邽߁jB̌AVobt@ɓB
			// ɒP̂Ńobt@TCYf[^nꂽꍇ́A̎
			// e|obt@pӂĂ̂B

			// obt@ɒǋLoΏI
			if (pBuffer_->CopyIn(pData, dataSize) == true)
			{
				return;
			}

			// obt@Ƀf[^݂
			int position = pBuffer_->GetPosition();
			if (position > 0)
			{
				// f[^L[ɓ
				ITsData^ data = gcnew TsData(pBuffer_->GetManagedData(), position);

				for (int i = 0; i < queueList_->Count; i++)
				{
					DataQueue^ queue = queueList_->default::get(i);
					queue->Enqueue(data);
				}

				// obt@V
				pBuffer_->Renew();
			}

			// f[^TCYobt@̃TCYȂ
			if (dataSize > pBuffer_->GetSize())
			{
				// e|obt@f[^TCYɍ킹ėpӂAf[^L[ɓ
				ManagedBuffer temp(dataSize);

				temp.CopyIn(pData, dataSize);

				ITsData^ data = gcnew TsData(temp.GetManagedData(), dataSize);

				for (int i = 0; i < queueList_->Count; i++)
				{
					DataQueue^ queue = queueList_->default::get(i);
					queue->Enqueue(data);
				}
				return;
			}

			// ̃obt@Ƀf[^
			pBuffer_->CopyIn(pData, dataSize);
		}

		System::Collections::Generic::IEnumerator<DataQueue^>^ DataQueueManager::GetEnumerator()
		{
			return queueList_->GetEnumerator();
		}

		System::Collections::IEnumerator^ DataQueueManager::IEnumerableGetEnumerator()
		{
			return queueList_->GetEnumerator();
		}
	}
}
