//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	namespace Internal
	{
		class ManagedBuffer
		{
		private:
			const DWORD bufferSize_;
			void *handle_;
			BYTE *pBuffer_;
			DWORD position_;

			void Allocate();
			void Free();

			ManagedBuffer(const ManagedBuffer &);
			void operator =(const ManagedBuffer &);

		public:
			ManagedBuffer(int bufferSize);
			~ManagedBuffer();

			const DWORD GetSize() const;
			const DWORD GetPosition() const;
			const BYTE *GetData() const;

			bool CopyIn(const BYTE *pData, DWORD size);

			array<System::Byte>^ GetManagedData();

			void Renew();
		};
	}
}
