//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#include "stdafx.h"

#include "MediaDecoderHandlerTrampoline.h"

namespace Bon
{
	namespace Internal
	{
		MediaDecoderEventArgs::MediaDecoderEventArgs(IMediaDecoder *pDecoder, int eventID, ULONG_PTR param)
			: pDecoder_(pDecoder), eventID_(eventID), param_(param)
		{
		}

		IMediaDecoder *MediaDecoderEventArgs::MediaDecoder::get()
		{
			return pDecoder_;
		}

		int MediaDecoderEventArgs::EventID::get()
		{
			return eventID_;
		}

		ULONG_PTR MediaDecoderEventArgs::Parameter::get()
		{
			return param_;
		}


		MediaDecoderHandlerTrampoline::MediaDecoderHandlerTrampoline(IBonObject *pOwner)
			: CBonObject(pOwner), callBack_(gcnew System::Threading::WaitCallback(WorkItemEntry))
		{
		}

		void MediaDecoderHandlerTrampoline::RegisterMediaDecoderEvent(MediaDecoderEventHandler^ handler)
		{
			handler_ = static_cast<MediaDecoderEventHandler^>(System::Delegate::Combine(handler_, handler));
		}

		void MediaDecoderHandlerTrampoline::UnregisterMediaDecoderEvent(MediaDecoderEventHandler^ handler)
		{
			handler_ = static_cast<MediaDecoderEventHandler^>(System::Delegate::Remove(handler_, handler));
		}

		const DWORD MediaDecoderHandlerTrampoline::OnDecoderEvent(IMediaDecoder *pDecoder, const DWORD dwEventID, const ULONG_PTR param)
		{
			// Cxg͒xlA񓯊Ƃ
			MediaDecoderEventArgs^ e = gcnew MediaDecoderEventArgs(pDecoder, static_cast<int>(dwEventID), param);
			System::Threading::ThreadPool::QueueUserWorkItem(callBack_,
				System::Collections::Generic::KeyValuePair<MediaDecoderEventHandler^, MediaDecoderEventArgs^>(handler_, e));

			return 0;
		}

		void MediaDecoderHandlerTrampoline::WorkItemEntry(System::Object^ argument)
		{
			System::Collections::Generic::KeyValuePair<MediaDecoderEventHandler^, MediaDecoderEventArgs^> pair =
				static_cast<System::Collections::Generic::KeyValuePair<MediaDecoderEventHandler^, MediaDecoderEventArgs^> >(argument);
			pair.Key->Invoke(pair.Value);
		}
	}
}
