//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	namespace Internal
	{
		ref class MediaDecoderEventArgs : public System::EventArgs
		{
		private:
			initonly IMediaDecoder *pDecoder_;
			initonly int eventID_;
			initonly ULONG_PTR param_;

		public:
			MediaDecoderEventArgs(IMediaDecoder *pDecoder, int eventID, ULONG_PTR param);

			property IMediaDecoder *MediaDecoder
			{
				IMediaDecoder *get();
			}

			property int EventID
			{
				int get();
			}

			property ULONG_PTR Parameter
			{
				ULONG_PTR get();
			}
		};

		delegate void MediaDecoderEventHandler(MediaDecoderEventArgs^ e);

		class MediaDecoderHandlerTrampoline
			: public CBonObject, public IMediaDecoderHandler
		{
		private:
			gcroot<MediaDecoderEventHandler^> handler_;
			gcroot<System::Threading::WaitCallback^> callBack_;

			static void WorkItemEntry(System::Object^ argument);

			virtual const DWORD OnDecoderEvent(IMediaDecoder *pDecoder, const DWORD dwEventID, const ULONG_PTR param);

			MediaDecoderHandlerTrampoline(const MediaDecoderHandlerTrampoline &);
			void operator =(const MediaDecoderHandlerTrampoline &);

		public:
			MediaDecoderHandlerTrampoline(IBonObject *pOwner = 0);

			DECLARE_IBONOBJECT(MediaDecoderHandlerTrampoline)

			void RegisterMediaDecoderEvent(MediaDecoderEventHandler^ handler);
			void UnregisterMediaDecoderEvent(MediaDecoderEventHandler^ handler);
		};
	}
}
