//////////////////////////////////////////////////////////////////////////
// BonSDK .NET binding interop library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.


#pragma once

namespace Bon
{
	ref class Tuner;

	public enum class TraceType
	{
		Debug = 1,
		Information = 2,
		Warning = 4,
		Error = 8
	};

	public delegate void TraceCallbackDelegate(TraceType type, System::String^ message);

	[System::Runtime::InteropServices::ComVisibleAttribute(true)]
	[System::Runtime::InteropServices::GuidAttribute("429F33E9-BB96-492e-B8F9-9C539086FF32")]
	[System::Runtime::InteropServices::ComDefaultInterfaceAttribute(ITunerFactory::typeid)]
	public ref class TunerFactory sealed
		: public ITunerFactory
	{
	private:
		static TunerFactory();

		array<ITunerDefinition^>^ tunerDefinitions_;
		void UpdateTunerDefinitions();

	internal:
		static TraceCallbackDelegate^ traceCallback_;

	public:
		static void SetTraceCallback(TraceCallbackDelegate^ traceCallback);
		static bool IsTraceTarget(TraceType type);

		TunerFactory();

		property int Count
		{
			virtual int get();
		}

		property ITunerDefinition^ default[int]
		{
			virtual ITunerDefinition^ get(int index);
		}

		virtual void Update();

		virtual System::Collections::IEnumerator^ GetEnumerator();
	};
}
