//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service remote controller
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Reflection;
using System.Text;
using System.Windows.Forms;
using Bon.Remoting;

namespace Bon
{
	public partial class AboutForm : Form
	{
		public AboutForm()
		{
			InitializeComponent();

			SortedDictionary<string, Assembly> assemblies = new SortedDictionary<string, Assembly>();
			foreach (Assembly assembly in AppDomain.CurrentDomain.GetAssemblies())
			{
				assemblies.Add(assembly.GetName().Name, assembly);
			}

			foreach (KeyValuePair<string, Assembly> entry in assemblies)
			{
				ListViewItem lvi = new ListViewItem(entry.Key);

				AssemblyName assemblyName = entry.Value.GetName();
				lvi.SubItems.Add(assemblyName.Version.ToString());
				lvi.SubItems.Add(assemblyName.ProcessorArchitecture.ToString());
				lvi.SubItems.Add(assemblyName.CultureInfo.ToString());
				byte[] publicKeyToken = assemblyName.GetPublicKeyToken();
				lvi.SubItems.Add(BitConverter.ToString(publicKeyToken).Replace("-", string.Empty).ToLowerInvariant());
				lvi.SubItems.Add(entry.Value.Location);

				assembliesListView.Items.Add(lvi);
			}
		}
	}
}
