//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections.Generic;
using System.Net.Mime;
using Microsoft.Win32;

namespace Bon
{
	/// <summary>
	/// gqContentTypeɃ}bvNXłB
	/// </summary>
	internal static class ContentTypeMapper
	{
		private static readonly Dictionary<string, string> contentTypes_ = new Dictionary<string, string>();

		/// <summary>
		/// ^CvCjVCUłB
		/// </summary>
		static ContentTypeMapper()
		{
			// fBA^Cvo^
			foreach (string name in Registry.ClassesRoot.GetSubKeyNames())
			{
				if (name.StartsWith(".") == true)
				{
					using (RegistryKey key = Registry.ClassesRoot.OpenSubKey(name, false))
					{
						string value = key.GetValue("Content Type", null) as string;
						if (string.IsNullOrEmpty(value) == false)
						{
							contentTypes_.Add(name.ToLowerInvariant(), value);
						}
					}
				}
			}
			contentTypes_[".dpr"] = MediaTypeNames.Text.Html;
		}

		/// <summary>
		/// f[^`w肵ȂContentType擾܂B
		/// </summary>
		public static string OctetStream
		{
			get
			{
				return MediaTypeNames.Application.Octet;
			}
		}

		/// <summary>
		/// gqContentTypeɃ}bv܂B
		/// </summary>
		/// <param name="extension">gq</param>
		/// <returns>ContentType</returns>
		/// <remarks>ΉContentType݂Ȃꍇnull</remarks>
		public static string Map(string extension)
		{
			string contentType = null;
			contentTypes_.TryGetValue(extension.ToLowerInvariant(), out contentType);
			return contentType;
		}
	}
}
