//////////////////////////////////////////////////////////////////////////
// BonSDK Stream service
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

using System;
using System.Collections;
using System.Runtime.Remoting.Lifetime;
using System.Security.Permissions;

namespace Bon
{
	internal sealed class RemoteEnumerator : MarshalByRefObject, IEnumerator
	{
		private readonly IEnumerator enumerator_;

		public RemoteEnumerator(IEnumerator enumerator)
		{
			enumerator_ = enumerator;
		}

		[SecurityPermission(SecurityAction.Demand, Flags = SecurityPermissionFlag.Infrastructure)]
		public override object InitializeLifetimeService()
		{
			ILease lease = (ILease)base.InitializeLifetimeService();
			if (lease.CurrentState == LeaseState.Initial)
			{
				lease.InitialLeaseTime = TimeSpan.FromSeconds(30);
				lease.SponsorshipTimeout = TimeSpan.FromMinutes(2);
				lease.RenewOnCallTime = TimeSpan.FromSeconds(2);
			}
			return lease;
		}

		public object Current
		{
			get
			{
				return enumerator_.Current;
			}
		}

		public bool MoveNext()
		{
			return enumerator_.MoveNext();
		}

		public void Reset()
		{
			enumerator_.Reset();
		}
	}
}
