//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// MediaBase.h: BonfBANX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <queue>


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// CMediaDataHeapNX
/////////////////////////////////////////////////////////////////////////////

// CMediaData ̃AP[^NXB
// ̎́AfobOrhł C malloc/free gpă[Nǐ
// \ƂA[Xrhł HeapCreate gpăq[v̈𕪊B
class BONAPI CMediaDataHeap :	public CBonObject,
					public IMediaDataHeap
{
private:
#if 1
	HANDLE m_Handle;
#endif

public:
// CBonObject
	DECLARE_IBONOBJECT(CMediaDataHeap)

	// fobOrhł͏TCY͖
	CMediaDataHeap(IBonObject *pOwner = 0, const DWORD dwInitialSpace = 65536);
	~CMediaDataHeap();

	BYTE *Allocate(DWORD size);
	void Free(BYTE *pBuffer);
};


/////////////////////////////////////////////////////////////////////////////
// IMediaDataNX
/////////////////////////////////////////////////////////////////////////////

// IMediaData C^[tFCX̊̎B
// ftHg̃q[vAP[^́AfobOrhł C malloc/free A[
// Xrhł͋ʂ̒P Win32 q[viAAvZXftHgq[vƂ͈ق
// jgpB
class BONAPI CMediaData :	public CBonObject,
					public IMediaData
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CMediaData)

// IMediaData
	virtual BYTE *GetData(void);
	virtual const BYTE *GetData(void) const;
	virtual const DWORD GetSize(void) const;

	virtual void SetAt(const DWORD dwPos, const BYTE byData);
	virtual const BYTE GetAt(const DWORD dwPos) const;

	virtual const DWORD SetData(const BYTE *pData, const DWORD dwDataSize);
	virtual const DWORD AddData(const BYTE *pData, const DWORD dwDataSize);
	virtual const DWORD AddData(const IMediaData *pData);
	virtual const DWORD AddByte(const BYTE byData);
	virtual const DWORD TrimHead(const DWORD dwTrimSize = 1UL);
	virtual const DWORD TrimTail(const DWORD dwTrimSize = 1UL);

	virtual const DWORD CopyData(const IMediaData *pSrc);
	virtual IMediaData *Clone(IMediaDataHeap *pHeap = 0) const;

	virtual const DWORD GetBuffer(const DWORD dwGetSize);

	virtual const DWORD SetSize(const DWORD dwSetSize);
	virtual const DWORD SetSize(const DWORD dwSetSize, const BYTE byFiller);
	
	virtual void ClearSize(void);

// CMediaData
	CMediaData(IBonObject *pOwner, IMediaDataHeap *pHeap = 0);
	CMediaData(const CMediaData &Operand);
	CMediaData(const BYTE *pData, const DWORD dwDataSize, IMediaDataHeap *pHeap = 0);
	virtual ~CMediaData(void);

	CMediaData & operator = (const CMediaData &Operand);

protected:
	template <typename T> IMediaData *InternalClone(IMediaDataHeap *pHeap) const
	{
		T *pNew = new T(m_pOwner, pHeap ? pHeap : m_pHeap);
		pNew->CopyData(this);
		return pNew;
	}

	DWORD m_dwDataSize;
	DWORD m_dwBuffSize;
	BYTE *m_pData;
	IMediaDataHeap *m_pHeap;
};


/////////////////////////////////////////////////////////////////////////////
// IMediaDecoderNX
/////////////////////////////////////////////////////////////////////////////

// fBAfR[_ƂȂNX͂̃NXpAOnInputMedia I[o[
// Chăf[^̏邱ƁB
// ʂ̃fBAfR[_Ƀf[^𑗏oꍇ́AOutputMedia ĂяoB
// m_Lock ̓CX^XŗL̃NeBJZNVƂĎgpoB
// RXgN^œnq[vAP[^ւ̃|C^́AGetMediaDataHeap
// Ŏ擾oB
class BONAPI CMediaDecoder :	public CBonObject,
						public IMediaDecoder
{
public:
// IMediaDecoder
	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool PlayDecoder(void);
	virtual const bool StopDecoder(void);
	virtual const bool ResetDecoder(void);

	virtual const bool SetOutputDecoder(IMediaDecoder *pDecoder, const DWORD dwOutputIndex = 0UL, const DWORD dwInputIndex = 0UL);
	virtual const bool InputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex = 0UL);
	virtual const bool InputMedia(const BYTE *pData, const DWORD dwSize, const DWORD dwInputIndex = 0UL);

// CMediaDecoder
	virtual ~CMediaDecoder(void);

protected:
	CMediaDecoder(IBonObject *pOwner, const DWORD dwInputNum = 1UL, const DWORD dwOutputNum = 1UL, IMediaDataHeap *pHeap = 0);

	virtual const bool OnPlay(void);
	virtual const bool OnStop(void);
	virtual const bool OnReset(void);
	virtual const bool OnInputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex);

	virtual IMediaDataHeap *GetMediaDataHeap() const;
	virtual const bool OutputMedia(const IMediaData *pMediaData, const DWORD dwOutptIndex = 0UL);
	virtual const DWORD SendDecoderEvent(const DWORD dwEventID, const ULONG_PTR param = NULL);

	CSmartLock m_Lock;

private:
	// o̓sf[^x[X
	struct TAG_OUTPUTDECODER
	{
		IMediaDecoder *pDecoder;
		DWORD dwInputIndex;
	} m_aOutputDecoder[16];

	IMediaDecoderHandler *m_pEventHandler;
	IMediaDataHeap *m_pHeap;

	const DWORD m_dwInputNum;
	const DWORD m_dwOutputNum;
};


/////////////////////////////////////////////////////////////////////////////
// CQueuedMediaDecoderNX
/////////////////////////////////////////////////////////////////////////////

// CMediaDecoder ̑ɎgpƁAInputMediaœ͂ꂽf[^L[
// ێAʃXbh OnInputMedia ĂяoB
// q[v̓ftHgŁÃCX^Xpɗpӂ邽߁AfЉy
// }`XbhbNyB
class BONAPI CQueuedMediaDecoder :	public CMediaDecoder
{
public:
// IMediaDecoder
	virtual const bool InputMedia(const IMediaData *pMediaData, const DWORD dwInputIndex = 0UL);
	virtual const bool InputMedia(const BYTE *pData, const DWORD dwSize, const DWORD dwInputIndex = 0UL);

	virtual const bool PlayDecoder(void);
	virtual const bool StopDecoder(void);
	virtual const bool ResetDecoder(void);

// CMediaDecoder
	virtual ~CQueuedMediaDecoder(void);

protected:
	CQueuedMediaDecoder(IBonObject *pOwner, const DWORD dwInputNum = 1UL, const DWORD dwOutputNum = 1UL, const DWORD maxQueueItemBits = 10, IMediaDataHeap *pHeap = new CMediaDataHeap());

	void SetName(LPCTSTR pName);
	void PurgeQueue();

private:
	void DequeueThread(CSmartThread<CQueuedMediaDecoder> &thread, const ISignal &bKillSignal, const ULONG_PTR param);

	struct QUEUE_DATA
	{
		IMediaData *pMediaData;
		DWORD dwInputIndex;
	};

	CSmartLock m_QueueLock;
	QUEUE_DATA *m_pQueueDatas;
	DWORD m_dwPushPosition;
	DWORD m_dwPopPosition;
	CSmartEvent m_Queued;

	CSmartThread<CQueuedMediaDecoder> *m_pDequeueThread;

	const DWORD m_dwMaxQueueItems;
};

}
