//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// ModCatalogBase.h: W[J^ONX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// W[J^ONX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CModCatalogBase	:	public CBonObject,
							public IBonModCatalog
{
public:
	struct MOD_CLASS_INFO
	{
		CBonString szBIId;	// C^tF[X
		CBonString szBCId;	// NX
		CBonString szDesc;	// NX̐
	};

// CBonObject
	DECLARE_IBONOBJECT(CModCatalogBase)

// IBonModCatalog
	virtual const WORD GetVersion(void) const;
	virtual const CBonString GetComment() const;
	virtual const CBonString GetAuthor() const;
	virtual const CBonString GetWebsite() const;
	virtual const BONGUID EnumClass(LPCTSTR lpszBIId, const DWORD dwIndex) const;
	virtual const CBonString GetClassDesc(const BONGUID ClassId) const;

// CModCatalogBase
	CModCatalogBase(IBonObject *pOwner);
	CModCatalogBase(IBonObject *pOwner, const MOD_CLASS_INFO *pClassInfo, const DWORD dwClassNum, const HMODULE hModule, const LPCTSTR lpszComment, const LPCTSTR lpszAuthor, const LPCTSTR lpszWebsite);
	CModCatalogBase(IBonObject *pOwner, const MOD_CLASS_INFO *pClassInfo, const DWORD dwClassNum, const WORD wVersion, const LPCTSTR lpszComment, const LPCTSTR lpszAuthor, const LPCTSTR lpszWebsite);
	virtual ~CModCatalogBase(void);
	
	const MOD_CLASS_INFO *m_pClassInfo;
	const DWORD m_dwClassNum;
	const HMODULE m_hModule;
	const WORD m_wVersion;
	const CBonString m_Comment;
	const CBonString m_Author;
	const CBonString m_Website;
};

}
