//////////////////////////////////////////////////////////////////////////
// BonSDK library header file
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// SyncObject.h: IuWFNgbp[NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


namespace Bon
{

/////////////////////////////////////////////////////////////////////////////
// NeBJZNVbp[NX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CSmartLock : public ILockObject
{
public:
	CSmartLock();
	virtual ~CSmartLock();
	
	virtual void Lock() const;
	virtual void Unlock() const;
	
private:
	mutable CRITICAL_SECTION m_CriticalSection;

	CSmartLock(const CSmartLock &);
	void operator =(const CSmartLock &);
};


/////////////////////////////////////////////////////////////////////////////
// ubNXR[vbNNX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CBlockLock
{
public:
	CBlockLock(const ILockObject &lock);
	CBlockLock(const ILockObject *pLock);
	virtual ~CBlockLock();
		
private:
	const ILockObject *m_pLock;

	CBlockLock(const CBlockLock &);
	void operator =(const CBlockLock &);
};


/////////////////////////////////////////////////////////////////////////////
// J[lIuWFNgNX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CKernelObject : public IKernelObject
{
public:
	virtual ~CKernelObject();

	const bool IsAssigned() const;
	const HANDLE UnsafeGetHandle() const;

	operator const bool() const;
	const bool operator !() const;

	const WaitResult Wait(const DWORD dwTimeout = INFINITE, const bool pumpMessage = false) const;

protected:
	CKernelObject(HANDLE handle = NULL, HANDLE invalid = NULL);
	void Assign(HANDLE handle);
	const bool Close();

private:
	HANDLE m_Invalid;
	HANDLE m_Handle;

	CKernelObject(const CKernelObject &);
	void operator =(const CKernelObject &);
};


/////////////////////////////////////////////////////////////////////////////
// Cxgbp[NX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CSmartEvent : public CKernelObject
{
public:
	CSmartEvent(const bool bManualReset = false, const bool bInitialState = false);
	const bool Close(void);

	const bool SetEvent(void);
	const bool PulseEvent(void);
	const bool ResetEvent(void);
};


/////////////////////////////////////////////////////////////////////////////
// ~[ebNXbp[NX
/////////////////////////////////////////////////////////////////////////////

class BONAPI CSmartMutex : public CKernelObject
{
public:
	CSmartMutex(void);

	const bool Create(LPCTSTR lpszName);
	const bool Close(void);

	static const bool IsExist(LPCTSTR lpszName);
};

}
