//////////////////////////////////////////////////////////////////////////
// BonSDK Core engine library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// RegCfgStorage.h: ėpRtBM[VXg[WNX(WXg)
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// ėpRtBM[VXg[WNX(WXg)
/////////////////////////////////////////////////////////////////////////////

class CRegCfgStorage :	public CBonObject,
						public IConfigStorage
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CRegCfgStorage)

// IConfigStorage
	virtual const bool OpenStorage(LPCTSTR lpszPathName = NULL, const bool bCreate = true);
	virtual const bool CloseStorage(void);

	virtual IConfigStorage * OpenSection(LPCTSTR lpszSection, const bool bCreate = true);
	virtual const DWORD GetSectionNum(void);
	virtual const CBonString EnumSection(const DWORD dwIndex);
	virtual const bool DeleteSection(LPCTSTR lpszSection);

	virtual const DWORD GetItemNum(void);
	virtual const CBonString EnumItem(const DWORD dwIndex);
	virtual const DWORD GetItemType(LPCTSTR lpszItem);
	virtual const bool DeleteItem(LPCTSTR lpszItem);

	virtual const bool SetBoolItem(LPCTSTR lpszItem, const bool bValue);
	virtual const bool SetIntItem(LPCTSTR lpszItem, const DWORD dwValue);
	virtual const bool SetTextItem(LPCTSTR lpszItem, LPCTSTR lpszValue);
	
	virtual const bool GetBoolItem(LPCTSTR lpszItem, const bool bDefault = false);
	virtual const DWORD GetIntItem(LPCTSTR lpszItem, const DWORD dwDefault = 0UL, const DWORD dwMax = 0xFFFFFFFFUL, const DWORD dwMin = 0x00000000UL);
	virtual const CBonString GetTextItem(LPCTSTR lpszItem, LPCTSTR lpszDefault = NULL);

// CRegCfgStorage
	CRegCfgStorage(IBonObject *pOwner);
	virtual ~CRegCfgStorage(void);

protected:
	HKEY m_hRegKey;
};
