//////////////////////////////////////////////////////////////////////////
// BonSDK Media decoder library
// Copyright (c) http://2sen.dip.jp/dtv/
//
// This is part of BonSDK.
// BonSDK comes with ABSOLUTELY NO WARRANTY;
// for details see 'GNU GENERAL PUBLIC LICENSE 2.0'.

// StandardTuningSpace.cpp: W`[jOXy[X
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "StandardTuningSpace.h"


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// W`[jOXy[X
/////////////////////////////////////////////////////////////////////////////

const CBonString CStandardTuningSpace::GetStandardTuningSpaceName(const STANDARD_TUNING_SPACES tuningSpace) const
{
	static const CBonString tuningSpaceName[5] = 
	{
		CBonString(TEXT("VHF")),
		CBonString(TEXT("UHF")),
		CBonString(TEXT("CATV")),
		CBonString(TEXT("BS")),
		CBonString(TEXT("CS110")),
	};

	switch (tuningSpace)
	{
	case TUNING_SPACE_VHF :
		return tuningSpaceName[TUNING_SPACE_VHF];
	case TUNING_SPACE_UHF :
		return tuningSpaceName[TUNING_SPACE_UHF];
	case TUNING_SPACE_CATV :
		return tuningSpaceName[TUNING_SPACE_CATV];
	case TUNING_SPACE_BS :
		return tuningSpaceName[TUNING_SPACE_BS];
	case TUNING_SPACE_CS110 :
		return tuningSpaceName[TUNING_SPACE_CS110];
	}
	return CBonString::GetEmpty();
}

const CBonString CStandardTuningSpace::GetStandardChannelName(const STANDARD_TUNING_SPACES tuningSpace, const DWORD dwChannel) const
{
	static const CBonString channelNameBS[11] = 
	{
		CBonString(TEXT("BS1/TS0 BS")),
		CBonString(TEXT("BS1/TS1 BS-i")),
		CBonString(TEXT("BS3/TS0 WOWOW")),
		CBonString(TEXT("BS3/TS1 BSWp")),
		CBonString(TEXT("BS9/TS0 BS11")),
		CBonString(TEXT("BS9/TS1 Star Channel HV")),
		CBonString(TEXT("BS9/TS2 TwellV")),
		CBonString(TEXT("BS13/TS0 BSe")),
		CBonString(TEXT("BS13/TS1 BStW")),
		CBonString(TEXT("BS15/TS1 NHK BS1/2")),
		CBonString(TEXT("BS15/TS2 NHK BS-hi"))
	};

	switch (tuningSpace)
	{
	case TUNING_SPACE_VHF :
		if(dwChannel < 12)
			return CBonString::Format(TEXT("VHF %1!lu!ch"), dwChannel);
		break;
	case TUNING_SPACE_UHF :
		if(dwChannel < 50)
			return CBonString::Format(TEXT("UHF %1!lu!ch"), dwChannel);
		break;
	case TUNING_SPACE_CATV :
		if(dwChannel < 51)
			return CBonString::Format(TEXT("CATV %1!lu!ch"), dwChannel);
		break;
	case TUNING_SPACE_BS :
		if(dwChannel < 11)
			return channelNameBS[dwChannel];
		break;
	case TUNING_SPACE_CS110 :
		if(dwChannel < 12)
			return CBonString::Format(TEXT("ND%1!lu! 110CS #%2!lu!"), (dwChannel + 1) * 2, dwChannel + 1);
		break;
	}
	return CBonString::GetEmpty();
}

CStandardTuningSpace::CStandardTuningSpace(IBonObject *pOwner)
	: CBonObject(pOwner)
{
}

CStandardTuningSpace::~CStandardTuningSpace(void)
{
}
